package es.claro.persistence;

public final class PersistenceManagerFactory {

   private static Class<? extends PersistenceManager> type = ScopedPersistenceManager.class;
   private static PersistenceManager singleton = createManager();

   public final static void register(final Class<? extends PersistenceManager> type) {
      PersistenceManagerFactory.type = type;
      //      singleton.closeEntityManagerFactory();
      singleton = createManager();
   }

   private static PersistenceManager createManager() {
      try {
         return type.newInstance();
      } catch (final InstantiationException e) {
         PersistenceManager.log.severe("cannot load PersistenceManager: " + type.getName());
         throw new RuntimeException(e);
      } catch (final IllegalAccessException e) {
         PersistenceManager.log.severe("cannot load PersistenceManager: " + type.getName());
         throw new RuntimeException(e);
      }
   }

   public static PersistenceManager getInstance() {
      return singleton;
   }

}
